田草博客

互联网田草博客


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件 | ID
-随机-|-分布-
-博客论坛-|-﨣﨤﨧﨨-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2024 - 3 48
     12
3456789
10111213141516
17181920212223
24252627282930
31


站点统计

最新评论



CapturePreviewImage : API 捕捉预览图像 How to display my custom web page in
未知 创建多行文字带属性块   [ 日期:2014-01-19 ]   [ 来自:本站原创 ]  HTML
原文来自:http://adndevblog.typepad.com/autocad/2013/06/creati ... -line-attribute-definition.html

Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.ApplicationServices
Public Class class1
    Friend Shared Sub CreateMyBlock()
        Dim db As Database = Application.DocumentManager.MdiActiveDocument.Database
        Using tr As Transaction = db.TransactionManager.StartTransaction()
            Dim bt As BlockTable = TryCast(tr.GetObject(db.BlockTableId, OpenMode.ForRead), BlockTable)
            If bt.Has("MyBlock") = False Then
                bt.UpgradeOpen()
                Dim btr As New BlockTableRecord()
                btr.Name = "MyBlock"
                btr.Origin = Point3d.Origin
                bt.Add(btr)
                tr.AddNewlyCreatedDBObject(btr, True)
                ' Attribute Definition
                Dim attdef As New AttributeDefinition(Point3d.Origin, "MilliSeconds\PSeconds\PMinutes", "Time", "Time ?", db.Textstyle)
                attdef.IsMTextAttributeDefinition = True
                btr.AppendEntity(attdef)
                tr.AddNewlyCreatedDBObject(attdef, True)
            End If
            tr.Commit()
        End Using
    End Sub

    Friend Shared Sub CreateMyBlockRef()
        Dim doc As Document = Application.DocumentManager.MdiActiveDocument
        Dim db As Database = doc.Database
        Dim ed As Editor = doc.Editor
        Dim ppo As New PromptPointOptions(vbLf & "Specify insertion point :")
        Dim ppr As PromptPointResult = ed.GetPoint(ppo)
        If ppr.Status <> PromptStatus.OK Then
            Return
        End If
        Dim insertionPoint As Point3d = ppr.Value
        Using tr As Transaction = db.TransactionManager.StartTransaction()
            Dim bt As BlockTable = TryCast(db.BlockTableId.GetObject(OpenMode.ForRead), BlockTable)
            Dim blockDef As BlockTableRecord = TryCast(bt("MyBlock").GetObject(OpenMode.ForRead), BlockTableRecord)
            Dim ms As BlockTableRecord = TryCast(bt(BlockTableRecord.ModelSpace).GetObject(OpenMode.ForWrite), BlockTableRecord)
            Dim blockRef As New BlockReference(insertionPoint, blockDef.ObjectId)
            ms.AppendEntity(blockRef)
            tr.AddNewlyCreatedDBObject(blockRef, True)
            For Each id As ObjectId In blockDef
                Dim obj As DBObject = id.GetObject(OpenMode.ForRead)
                Dim attDef As AttributeDefinition = TryCast(obj, AttributeDefinition)
                If (attDef IsNot Nothing) AndAlso (Not attDef.Constant) Then
                    Dim attRef As New AttributeReference()
                    attRef.SetAttributeFromBlock(attDef, blockRef.BlockTransform)
                    attRef.TextString = [String].Format("MilliSeconds : {0}\PSeconds : {1}\PMinutes : {2}",DateTime.Now.Millisecond.ToString(), DateTime.Now.Second.ToString(), DateTime.Now.Minute.ToString())
                    blockRef.AttributeCollection.AppendAttribute(attRef)
                    tr.AddNewlyCreatedDBObject(attRef, True)
                End If
            Next
            tr.Commit()
        End Using
    End Sub

    <CommandMethod("Test")> _
    Public Shared Sub TestMethod()
        CreateMyBlock()
        CreateMyBlockRef()
    End Sub
End Class


【多行属性块.rar】点击下载此文件

[本日志由 tiancao1001 于 2014-01-19 01:02 AM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:1*3=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©